
//  Serializes the given object to JSON, escapes, and passes to Java.
function appAction(objJson) {
    var jsonString = (JSON.stringify(objJson));
    var URLString = escape(jsonString);
    UtdAndroid.appAction(URLString);
}

// Passes the given String to Java.
function getResource(assetType) {
    UtdAndroid.getResource(assetType);
}

// Loads an HTML resource.
function openStaticContentItem(id) {
	var aa = {
	    "data": [ { "id": id } ],
		"meta": { "assetType": "resource" }
	};
	appAction(aa);
}

utd = {
		openUrl : function(url) {
			window.location = url;
		}
};

/**
 * Gets the x,y coord of an object, given the object
 */
function getObjectCoord(obj) {
	var xCoord = 0;
	var yCoord = 0;
	
	if (obj) {
		xCoord = obj.offsetLeft;
		yCoord = obj.offsetTop;
		
		var tempEl = obj.offsetParent;	
		while (tempEl != null) {
			xCoord += tempEl.offsetLeft;
			yCoord += tempEl.offsetTop;
			tempEl = tempEl.offsetParent;
		}
	}
	return {"x":xCoord, "y":yCoord};
}

function findObjectOfType(parent, tagName) {
	tagName = tagName.toLowerCase();
	var output = null;
	if (parent) {
        if (parent.nodeType == 1) {
            if (parent.tagName.toLowerCase() == tagName) {
                output = parent;
            } else {
                for (var i = parent.childNodes.length - 1; i >= 0; i--) {
					output = findObjectOfType(parent.childNodes[i], tagName);
					if (output != null) {
						break;
					}
                }
            }
        }
    }
	return output;
}

function getMetaWithNameAndContentPrefix(metaName, contentPrefix) {
    var output = null;
    
    metaName = metaName.toLowerCase();
    contentPrefix = contentPrefix.toLowerCase();
    
    var objMetaList = document.getElementsByTagName("meta");
    for (var ii=0; ii<objMetaList.length; ii++) {
        if (objMetaList[ii].name.toLowerCase() == metaName && objMetaList[ii].content.toLowerCase().indexOf(contentPrefix) == 0) {
            output = objMetaList[ii];
            break;
        }
    }
    return output;
}

function setViewportWidth(width) {
    var metaElement = getMetaWithNameAndContentPrefix("viewport", "width=");
    if (metaElement == null) {
        metaElement = document.createElement('meta');
        // set properties
        metaElement.setAttribute("name", "viewport");
        var objHead = document.getElementsByTagName('head')[0];
        objHead.appendChild(metaElement);
    }
    metaElement.setAttribute("content", "width=" + width + ";");
}

function getElementsByTagNames(list,obj) {
	if (!obj) var obj = document;
	var tagNames = list.split(',');
	var resultArray = new Array();
	for (var i=0;i<tagNames.length;i++) {
		var tags = obj.getElementsByTagName(tagNames[i]);
		for (var j=0;j<tags.length;j++) {
			resultArray.push(tags[j]);
		}
	}
	var testNode = resultArray[0];
	if (!testNode) return [];
	if (testNode.sourceIndex) {
		resultArray.sort(function (a,b) {
                         return a.sourceIndex - b.sourceIndex;
                         });
	}
	else if (testNode.compareDocumentPosition) {
		resultArray.sort(function (a,b) {
                         return 3 - (a.compareDocumentPosition(b) & 6);
                         });
	}
	return resultArray;
}

function getClosestParagraphIdToTopOfPage(customMarkerId) {
    var closestParagraphId = null;
    
    var currentScrollHeight = window.pageYOffset;
    if (currentScrollHeight > 0) {
        var existingObj = document.getElementById(customMarkerId);
        if (existingObj != null) {
            existingObj.removeAttribute("id");
        }
        var allParagraphs = getElementsByTagNames('p,div,li');
        var closestDistance = null;
        var closestParagraph = null;
        var percDiff = null;
        
        for(var ii=0; ii<allParagraphs.length; ii++) {
            var curP = allParagraphs[ii];
            var objCoord = getObjectCoord(curP);
            var distance = currentScrollHeight - objCoord.y;
            var absDistance = Math.abs(distance);
            
            if (closestParagraph == null) {
                closestParagraph = curP;
                closestDistance = distance;
            } else {
                if (distance < -30) { //30 pixel offset
                    break;   
                }
                
                if (absDistance < closestDistance) {
                    closestParagraph = curP;
                    closestDistance = absDistance;
                }
            }
        }
        
        if (closestParagraph != null) {
            if (closestParagraph.id) {
                closestParagraphId = closestParagraph.id;
            } else {
                closestParagraph.setAttribute("id", customMarkerId);
                closestParagraphId = customMarkerId;
            }
        }
    }
//    return closestParagraphId;
    UtdAndroid.setParagraphIdBeforeRotation(closestParagraphId);
}

function scrollToAnchor(anchorId){
	var objAnchor = document.getElementById(anchorId);
	if (objAnchor) {
		//for older devices
		var objCoord = getObjectCoord(objAnchor);
		window.scrollTo(0, objCoord.y);
		
		//for newer devices
		objAnchor.scrollIntoView(true);
	}
}